#line 1 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/timers.c"
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
#line 26 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
struct timers
{
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 44 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
void init_timerpool(void);
#line 59 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
unsigned short int get_timer(void);
#line 73 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
void free_timer(unsigned short int nbr);
#line 88 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 102 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 116 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
void irqhandler_timer(void);
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/uart1.h"
#line 18 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/uart1.h"
typedef void (*tPointerFcn)(void);
typedef char *pnt;


 typedef struct rx_q_struct
 {
 int RxIn;
 int RxOut;
 char RxQueue[ 64 ];
 } rx_q_struct;


typedef struct tx_q_struct
{
 int TxIn;
 int TxOut;
 pnt TxQueue[ 32 ];
} tx_q_struct;




void UART1_SetBaud(void);
void UART1_StartRx(void);
void UART1_StartTx(void);

void InitUART1(void);
void UART1_TxQueueInit(void);
void UART1_RxQueueInit(void);

void UART1_SendMsg(char *s);
void UART1_CheckQueue(void);
void UART1_PutQueue(char *msg);
char UART1_GetChar(char *rxbyte);


void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);
#line 12 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/timers.c"
struct timers TimerPool[ 10 ];
#line 27 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/timers.c"
void init_timerpool(void)
{
 unsigned short int i;

 for (i=0; i <  10 ; i++)
 {
 TimerPool[i].TimerField = 0;
 TimerPool[i].Free =  1 ;
 }
}
#line 50 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/timers.c"
unsigned short int get_timer(void)
{
 unsigned short int i;
 unsigned short int FirstMatch;

 for (i=0; i <  10 ; i++)
 {
 if (TimerPool[i].Free ==  1 )
 {


 TimerPool[i].Free =  0 ;
 FirstMatch = i;
 return FirstMatch;
 }
 }


 UART1_PutQueue("TIMERS: No Timers, Resetting..\r\n");

 return (0);
}
#line 85 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/timers.c"
void free_timer(unsigned short int nbr)
{

 if (nbr > ( 10 -1))
 return;

 TimerPool[nbr].Free =  1 ;
}
#line 107 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/timers.c"
void set_timer(unsigned short int nbr, unsigned long int tout)
{
 unsigned long int val;


 if (nbr > ( 10 -1))
 return;

 if (TimerPool[nbr].Free ==  1 )
 return;


 val = tout;


 TimerPool[nbr].TimerField = val;
}
#line 137 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/timers.c"
unsigned long int check_timer(unsigned short int nbr)
{
 return TimerPool[nbr].TimerField;
}
#line 154 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/timers.c"
void irqhandler_timer(void)
{
 unsigned short int i;

 for (i=0; i< 10 ; i++)
 {
 if (TimerPool[i].Free ==  0  && TimerPool[i].TimerField != 0)
 TimerPool[i].TimerField--;
 }
}
