_init_timerpool:
;timers.c,27 :: 		void init_timerpool(void)
;timers.c,31 :: 		for (i=0; i < NUMTIMERS; i++)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_init_timerpool0:
; i start address is: 16 (R4)
ANDI	R2, R4, 255
SLTIU	R2, R2, 10
BNE	R2, R0, L__init_timerpool20
NOP	
J	L_init_timerpool1
NOP	
L__init_timerpool20:
;timers.c,33 :: 		TimerPool[i].TimerField = 0;
ANDI	R2, R4, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
SW	R0, 0(R2)
;timers.c,34 :: 		TimerPool[i].Free = TRUE;
ANDI	R2, R4, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 4
ORI	R2, R0, 1
SB	R2, 0(R3)
;timers.c,31 :: 		for (i=0; i < NUMTIMERS; i++)
ADDIU	R2, R4, 1
ANDI	R4, R2, 255
;timers.c,35 :: 		}
; i end address is: 16 (R4)
J	L_init_timerpool0
NOP	
L_init_timerpool1:
;timers.c,36 :: 		}
L_end_init_timerpool:
JR	RA
NOP	
; end of _init_timerpool
_get_timer:
;timers.c,50 :: 		unsigned short int get_timer(void)
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;timers.c,55 :: 		for (i=0; i < NUMTIMERS; i++)
SW	R25, 4(SP)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_get_timer3:
; i start address is: 16 (R4)
ANDI	R2, R4, 255
SLTIU	R2, R2, 10
BNE	R2, R0, L__get_timer22
NOP	
J	L_get_timer4
NOP	
L__get_timer22:
;timers.c,57 :: 		if (TimerPool[i].Free == TRUE)
ANDI	R2, R4, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 4
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__get_timer23
NOP	
J	L_get_timer6
NOP	
L__get_timer23:
;timers.c,61 :: 		TimerPool[i].Free = FALSE;
ANDI	R2, R4, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 4
SB	R0, 0(R2)
;timers.c,63 :: 		return FirstMatch;  // Return Handle
ANDI	R2, R4, 255
; i end address is: 16 (R4)
J	L_end_get_timer
NOP	
;timers.c,64 :: 		}
L_get_timer6:
;timers.c,55 :: 		for (i=0; i < NUMTIMERS; i++)
; i start address is: 16 (R4)
ADDIU	R2, R4, 1
ANDI	R4, R2, 255
;timers.c,65 :: 		}
; i end address is: 16 (R4)
J	L_get_timer3
NOP	
L_get_timer4:
;timers.c,68 :: 		UART1_PutQueue("TIMERS: No Timers, Resetting..\r\n");
LUI	R25, #hi_addr(?lstr1_timers+0)
ORI	R25, R25, #lo_addr(?lstr1_timers+0)
JAL	_UART1_PutQueue+0
NOP	
;timers.c,70 :: 		return (0);
MOVZ	R2, R0, R0
;timers.c,71 :: 		}
;timers.c,70 :: 		return (0);
;timers.c,71 :: 		}
L_end_get_timer:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _get_timer
_free_timer:
;timers.c,85 :: 		void free_timer(unsigned short int nbr)
;timers.c,88 :: 		if (nbr > (NUMTIMERS-1))
ANDI	R2, R25, 255
SLTIU	R2, R2, 10
BEQ	R2, R0, L__free_timer25
NOP	
J	L_free_timer7
NOP	
L__free_timer25:
;timers.c,89 :: 		return;
J	L_end_free_timer
NOP	
L_free_timer7:
;timers.c,91 :: 		TimerPool[nbr].Free = TRUE;
ANDI	R2, R25, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
ADDIU	R3, R2, 4
ORI	R2, R0, 1
SB	R2, 0(R3)
;timers.c,92 :: 		}
L_end_free_timer:
JR	RA
NOP	
; end of _free_timer
_set_timer:
;timers.c,107 :: 		void set_timer(unsigned short int nbr, unsigned long int tout)
;timers.c,112 :: 		if (nbr > (NUMTIMERS-1))
ANDI	R2, R25, 255
SLTIU	R2, R2, 10
BEQ	R2, R0, L__set_timer27
NOP	
J	L_set_timer8
NOP	
L__set_timer27:
;timers.c,113 :: 		return;
J	L_end_set_timer
NOP	
L_set_timer8:
;timers.c,115 :: 		if (TimerPool[nbr].Free == TRUE)
ANDI	R2, R25, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 4
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__set_timer28
NOP	
J	L_set_timer9
NOP	
L__set_timer28:
;timers.c,116 :: 		return;
J	L_end_set_timer
NOP	
L_set_timer9:
;timers.c,122 :: 		TimerPool[nbr].TimerField = val;
ANDI	R2, R25, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
SW	R26, 0(R2)
;timers.c,123 :: 		}
L_end_set_timer:
JR	RA
NOP	
; end of _set_timer
_check_timer:
;timers.c,137 :: 		unsigned long int check_timer(unsigned short int nbr)
;timers.c,139 :: 		return TimerPool[nbr].TimerField;
ANDI	R2, R25, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
LW	R2, 0(R2)
;timers.c,140 :: 		}
L_end_check_timer:
JR	RA
NOP	
; end of _check_timer
_irqhandler_timer:
;timers.c,154 :: 		void irqhandler_timer(void)
;timers.c,158 :: 		for (i=0; i<NUMTIMERS; i++)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_irqhandler_timer10:
; i start address is: 16 (R4)
ANDI	R2, R4, 255
SLTIU	R2, R2, 10
BNE	R2, R0, L__irqhandler_timer31
NOP	
J	L_irqhandler_timer11
NOP	
L__irqhandler_timer31:
;timers.c,160 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
ANDI	R2, R4, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 4
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BEQ	R2, R0, L__irqhandler_timer32
NOP	
J	L__irqhandler_timer18
NOP	
L__irqhandler_timer32:
ANDI	R2, R4, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R2, R2, R3
LW	R2, 0(R2)
BNE	R2, R0, L__irqhandler_timer34
NOP	
J	L__irqhandler_timer17
NOP	
L__irqhandler_timer34:
L__irqhandler_timer16:
;timers.c,161 :: 		TimerPool[i].TimerField--;
ANDI	R2, R4, 255
SLL	R3, R2, 3
LUI	R2, #hi_addr(_TimerPool+0)
ORI	R2, R2, #lo_addr(_TimerPool+0)
ADDU	R3, R2, R3
LW	R2, 0(R3)
ADDIU	R2, R2, -1
SW	R2, 0(R3)
;timers.c,160 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
L__irqhandler_timer18:
L__irqhandler_timer17:
;timers.c,158 :: 		for (i=0; i<NUMTIMERS; i++)
ADDIU	R2, R4, 1
ANDI	R4, R2, 255
;timers.c,162 :: 		}
; i end address is: 16 (R4)
J	L_irqhandler_timer10
NOP	
L_irqhandler_timer11:
;timers.c,163 :: 		}
L_end_irqhandler_timer:
JR	RA
NOP	
; end of _irqhandler_timer
