unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  StdCtrls, IdAntiFreezeBase, IdAntiFreeze;

type
  TForm1 = class(TForm)
    IdTCPClient1: TIdTCPClient;
    Memo1: TMemo;
    Send: TButton;
    IdAntiFreeze1: TIdAntiFreeze;
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure SendClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  LF  = #10;  //line feed
  CR  = #13;  //carriage return

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := '192.168.2.4';
  Edit2.Text := '1234';
  Edit3.Text := 'Hello';
end;

procedure TForm1.IdTCPClient1Connected(Sender: TObject);
begin
  Memo1.Lines.Add('Connected');
end;

procedure TForm1.SendClick(Sender: TObject);
var
  s: string;
begin
  try
    IdTCPClient1.WriteLn(Edit3.Text+CR);
    s := IdTCPClient1.ReadLn(#10);
  except
    on E: Exception do
      Memo1.Lines.Add('Error:'+E.Message);
  end;

  Memo1.Lines.Add(s);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (IdTCPClient1.Connected) then
    IdTCPClient1.Disconnect;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  try
    IdTCPClient1.Host := Edit1.Text;
    IdTCPClient1.Port := StrToInt(Edit2.Text);
    IdTCPClient1.Connect(1000);
  except
    on E: Exception do
      Memo1.Lines.Add('Error:'+E.Message);
  end;
end;

end.
